unit hiMST_SelfDrawManager;

interface
     
uses Windows, Messages, Kol, Share, Debug;

type
  TISelfDrawManager = record
    customdrawheader: procedure (ItemIdx: Integer; const Rect: TRect; ItemState: integer; TextItem: string)of object;
    customdrawitem: function(Sender: PControl; DC: HDC; Stage: Cardinal;
                         ItemIdx, SubItemIdx: Integer; const Rect: TRect;
                         ItemState: TDrawState; var TextColor, BackColor,
                         NewCurIdx: integer; SmIList, StIList:PImageList): Cardinal of object;
    stagedraw: procedure(ind: integer) of object;
    sethandles: procedure (h1, h2: THandle) of object;
  end;
  ISelfDrawManager = ^TISelfDrawManager;



  THIMST_SelfDrawManager = class(TDebug)
   private
     twbm: TISelfDrawManager;
     hHandle, hHeader: THandle;
     lastStage: Cardinal;
     
     procedure TWBMStageDraw(ind: integer);
     procedure TWBMSetHandles(h1, h2: THandle);
     procedure TWBMCustomDrawHeader(ItemIdx: Integer; const Rect: TRect; ItemState: integer; TextItem: string);
     function TWBMCustomDrawItem(Sender: PControl; DC: HDC; Stage: Cardinal;
                             ItemIdx, SubItemIdx: Integer; const Rect: TRect;
                             ItemState: TDrawState; var TextColor, BackColor,
                             NewCurIdx: integer; SmIList, StIList: PImageList): Cardinal;
   public
     _data_DrawFlag: THI_Event;
     _prop_Name: string;
     _event_onStartDrawCells: THI_Event;
     _event_onDataCell: THI_Event; 
     _event_onEndDrawCells: THI_Event;
     _event_onStartDrawHeader: THI_Event;
     _event_onDataHeader: THI_Event;
     _event_onEndDrawHeader: THI_Event;
     
     constructor Create;
     function getInterfaceSelfDrawManager: ISelfDrawManager;
     procedure _var_Handle(var _Data: TData; Index: word);
     procedure _var_HandleHeader(var _Data: TData; Index: word);
  end;

implementation

constructor THIMST_SelfDrawManager.Create;
begin
  inherited;
  twbm.customdrawheader := TWBMCustomDrawHeader;
  twbm.customdrawitem := TWBMCustomDrawItem;
  twbm.stagedraw :=  TWBMStageDraw;
  twbm.sethandles :=  TWBMSetHandles;
end;

procedure THIMST_SelfDrawManager.TWBMStageDraw;// 
begin
  case ind of
   0: _hi_OnEvent(_event_onStartDrawCells);
   1: _hi_OnEvent(_event_onEndDrawCells);
   2: _hi_OnEvent(_event_onStartDrawHeader);
   3: _hi_OnEvent(_event_onEndDrawHeader);
  end;
end;

procedure THIMST_SelfDrawManager.TWBMSetHandles;
begin
  hHandle := h1;
  hHeader := h2;
  _debug;
end;

function THIMST_SelfDrawManager.getInterfaceSelfDrawManager;
begin
  Result := @twbm;
end;

procedure THIMST_SelfDrawManager.TWBMCustomDrawHeader;//  
var
  ARect: TRect;
  _Data, Data, dRow, dLeft, dTop, dWidth, dHeight, dString, dItemState: TData;
begin
    dtInteger(Data, ItemIdx);// 
    dtInteger(dLeft, Rect.Left);//   
    dtInteger(dTop, 0);// 
    dtInteger(dWidth, Rect.Right);// 
    dtInteger(dHeight, Rect.Bottom);// 
    dtString(dString, TextItem);//      
    dtInteger(dItemState, ItemState - 512);//   (1 - , 0 - ) 

    Data.ldata:= @dLeft;
    dLeft.ldata:= @dTop;
    dTop.ldata:= @dWidth;
    dWidth.ldata:= @dHeight;
    dHeight.ldata:= @dString;
    dString.ldata:= @dItemState;
    _hi_OnEvent(_event_onDataHeader,data);
end;

function THIMST_SelfDrawManager.TWBMCustomDrawItem;
var
  ARect: TRect;
  _Data, Data, dRow, dLeft, dTop, dWidth, dHeight, dString, dItemState: TData;
   IState: integer;
begin
  //  _hi_OnEvent(_event_onDataCell, Stage);
  Result:= CDRF_DODEFAULT;
 ///////////////////////      //////////////////////////////
   if Stage = CDDS_SUBITEM OR CDDS_ITEMPREPAINT {196609} then begin   //   
    ARect := Sender.LVSubItemRect(ItemIdx,SubItemIdx); //   
    if SubItemIdx = 0 then ARect.Right := Arect.Left + Sender.LVColWidth[SubItemIdx]; //  

    dtInteger(Data, ItemIdx);
    dtInteger(dRow, SubItemIdx);  
    dtInteger(dLeft, ARect.Left);  
    dtInteger(dTop, ARect.Top);
    dtInteger(dWidth, ARect.Right - ARect.Left);
    dtInteger(dHeight, ARect.Bottom - ARect.Top);
    dtString(dString, Sender.LVItems[ItemIdx, SubItemIdx]);   
    if odsSelected in ItemState then IState := 1 else IState := 0;
    dtInteger(dItemState, IState); 

    Data.ldata:= @dRow;
    dRow.ldata:= @dLeft;
    dLeft.ldata:= @dTop;
    dTop.ldata:= @dWidth;
    dWidth.ldata:= @dHeight;
    dHeight.ldata:= @dString;
    dString.ldata:= @dItemState;

    _hi_OnEvent(_event_onDataCell, Data);
    if ReadInteger(_data,_data_DrawFlag) = 0 // 0    
     then Result:= CDRF_DODEFAULT            // 
      else Result:= CDRF_SKIPDEFAULT;        //   (  )
   end;
lastStage := Stage;
///////////////////////////////////////////////////////////////////////////////////////
end;

procedure THIMST_SelfDrawManager._var_Handle;
begin
  dtInteger(_Data, hHandle);
end;

procedure THIMST_SelfDrawManager._var_HandleHeader;
begin
  dtInteger(_Data, hHeader);
end;

end.